Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/IPushEvaluator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/IPushEvaluator.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/IPushEvaluator.cs	(revision 15289)
@@ -0,0 +1,16 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator {
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+
+  public interface IPushEvaluator : IDeepCloneable {
+    EvaluationResult EvaluateTest(IReadOnlyPushConfiguration config, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program);
+    EvaluationResult EvaluateTest(PushInterpreterPool pool, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTraining(IReadOnlyPushConfiguration config, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program);
+    EvaluationResult EvaluateTraining(PushInterpreterPool pool, PushProgram program, IRandom random);
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/PushBenchmarkSuiteEvaluator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/PushBenchmarkSuiteEvaluator.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/PushBenchmarkSuiteEvaluator.cs	(revision 15289)
@@ -0,0 +1,341 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator {
+  using System;
+  using System.Collections.Generic;
+  using System.Globalization;
+
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Parameters;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  [StorableClass]
+  public class PushBenchmarkSuiteEvaluator : ParameterizedNamedItem, IPushEvaluator {
+
+    private const string DataBoundsParameterName = "DataBounds";
+    private const string DataParameterName = "Data";
+    private const string DataParameterDescription = "Program Synthesis";
+
+    public PushBenchmarkSuiteEvaluator() {
+      Parameters.Add(new FixedValueParameter<DataBounds>(DataBoundsParameterName));
+
+      Parameters.Add(new ValueParameter<ProblemData>(
+        DataParameterName,
+        DataParameterDescription));
+    }
+
+    public PushBenchmarkSuiteEvaluator(ProblemData data) : this() {
+      LoadData(data);
+    }
+
+    [StorableConstructor]
+    public PushBenchmarkSuiteEvaluator(bool deserializing) : base(deserializing) { }
+
+    public PushBenchmarkSuiteEvaluator(PushBenchmarkSuiteEvaluator origin, Cloner cloner) : base(origin, cloner) {
+      Data = cloner.Clone(origin.Data);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushBenchmarkSuiteEvaluator(this, cloner);
+    }
+
+    public IValueParameter<ProblemData> DataParameter
+    {
+      get { return (IValueParameter<ProblemData>)Parameters[DataParameterName]; }
+    }
+
+    public ProblemData Data
+    {
+      get { return DataParameter.Value; }
+      set { DataParameter.Value = value; }
+    }
+
+    public IValueParameter<DataBounds> DataBoundsParameter
+    {
+      get { return (IValueParameter<DataBounds>)Parameters[DataBoundsParameterName]; }
+    }
+
+    public DataBounds DataBounds
+    {
+      get { return DataBoundsParameter.Value; }
+      set { DataBoundsParameter.Value = value; }
+    }
+
+    public void LoadData(ProblemData data) {
+      Data = data;
+
+      DataBounds.TrainingRange.Start = 0;
+      DataBounds.TrainingRange.End = Data.TrainingCount;
+      DataBounds.TestRange.Start = Data.TrainingCount;
+      DataBounds.TestRange.End = Data.TrainingCount + Data.TestCount;
+    }
+
+    public EvaluationResult Evaluate(IPushInterpreter interpreter, PushProgram program, int start, int end) {
+      var length = end - start;
+      if (length <= 0) return null;
+
+      var evaluationResult = new EvaluationResult(length);
+
+      for (var i = start; i < end; i++) {
+        var result = Evaluate(interpreter, program, i);
+        evaluationResult.ExampleQualities[i - start] = result;
+        evaluationResult.AvgQuality += result;
+        interpreter.Reset();
+      }
+
+      evaluationResult.AvgQuality /= length;
+
+      return evaluationResult;
+    }
+
+    public EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program) {
+      return Evaluate(interpreter, program, DataBounds.TestRange.Start, DataBounds.TestRange.End);
+    }
+
+    public EvaluationResult EvaluateTest(IReadOnlyPushConfiguration config, PushProgram program, IRandom random) {
+      var interpreter = new PushInterpreter(config, random);
+      return EvaluateTest(interpreter, program);
+    }
+
+    public EvaluationResult EvaluateTest(PushInterpreterPool pool, PushProgram program, IRandom random) {
+      using (var interpreter = pool.Create(random)) {
+        return EvaluateTest(interpreter, program);
+      }
+    }
+
+    public EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program) {
+      return Evaluate(interpreter, program, DataBounds.TrainingRange.Start, DataBounds.TrainingRange.End);
+    }
+
+    public EvaluationResult EvaluateTraining(IReadOnlyPushConfiguration config, PushProgram program, IRandom random) {
+      var interpreter = new PushInterpreter(config, random);
+      return EvaluateTraining(interpreter, program);
+    }
+
+    public EvaluationResult EvaluateTraining(PushInterpreterPool pool, PushProgram program, IRandom random) {
+      using (var interpreter = pool.Create(random)) {
+        return EvaluateTraining(interpreter, program);
+      }
+    }
+
+    public double Evaluate(IPushInterpreter interpreter, PushProgram program, int exampleIndex) {
+      var example = Data.Examples[exampleIndex];
+
+      interpreter.InitExample(example);
+      interpreter.Run(program);
+
+      switch (Data.ProblemType) {
+        case ProblemType.NumberIO: return NumberIo(interpreter, example);
+        case ProblemType.Median: return Median(interpreter, example);
+      }
+
+      return Default(interpreter, example);
+    }
+
+    private double Default(IPushInterpreter interpreter, Example example) {
+      var integerDiff = GetDiff(example.OutputInteger, interpreter.IntegerStack, Data.WorstResult, IntegerDiffer);
+      var floatDiff = GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, (a, b) => FloatDiffer(a, b, example.OutputFloatPrecision));
+      var booleanDiff = GetDiff(example.OutputBoolean, interpreter.BooleanStack, Data.WorstResult, BooleanDiffer);
+      var stringDiff = GetDiff(example.OutputString, interpreter.StringStack, Data.WorstResult, StringDiffer);
+      var charDiff = GetDiff(example.OutputChar, interpreter.CharStack, Data.WorstResult, CharDiffer);
+      var printDiff = GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, Data.WorstResult);
+      var integerVectorDiff = GetVectorDiff(example.OutputIntegerVector, interpreter.IntegerVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, IntegerDiffer));
+      var floatVectorDiff = GetVectorDiff(example.OutputFloatVector, interpreter.FloatVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, (x, y) => FloatDiffer(x, y, example.OutputFloatVectorPrecision)));
+      var stringVectorDiff = GetVectorDiff(example.OutputStringVector, interpreter.StringVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, StringDiffer));
+
+      var result =
+          integerDiff
+        + floatDiff
+        + booleanDiff
+        + stringDiff
+        + charDiff
+        + printDiff
+        + integerVectorDiff
+        + floatVectorDiff
+        + stringVectorDiff;
+
+      return result;
+    }
+
+    private double Median(IPushInterpreter interpreter, Example example) {
+      return interpreter.PrintStack.IsEmpty || !interpreter.PrintStack.ToString().Equals(example.OutputPrint) ? 1 : 0;
+    }
+
+    private double NumberIo(IPushInterpreter interpreter, Example example) {
+      if (interpreter.PrintStack.IsEmpty)
+        return Data.WorstResult;
+
+      var printResult = interpreter.PrintStack.ToString();
+
+      double value;
+      if (double.TryParse(printResult, NumberStyles.Number | NumberStyles.AllowDecimalPoint, CultureInfo.InvariantCulture, out value)) {
+        var diff = Math.Abs(example.OutputFloat[0] - value);
+        var result = Math.Min(diff, Data.WorstResult);
+
+        return result;
+      }
+
+      var penaltyError = Data.WorstResult / 4.0d;
+      var levenshteinDistance = GetPrintDiffer(
+        example.OutputPrint,
+        printResult,
+        Data.WorstResult);
+
+      return levenshteinDistance + penaltyError;
+    }
+
+    private static double FloatDiffer(double a, double b, int digits) {
+      var result = Math.Round(a, digits) - Math.Round(b, digits);
+
+      // ReSharper disable once CompareOfFloatsByEqualityOperator
+      if (result == double.MinValue || double.IsPositiveInfinity(result) || double.IsNaN(result))
+        return double.MaxValue;
+
+      // ReSharper disable once CompareOfFloatsByEqualityOperator
+      if (result == double.MaxValue || double.IsNegativeInfinity(result))
+        return double.MinValue;
+
+      return Math.Abs(result);
+    }
+
+    private static double IntegerDiffer(long a, long b) {
+      var result = a - b;
+
+      return result == long.MinValue ? long.MaxValue : Math.Abs(result);
+    }
+
+    private static double BooleanDiffer(bool a, bool b) {
+      return a == b ? 0 : 1;
+    }
+
+    private static double StringDiffer(string a, string b) {
+      return LevenshteinDistance(a, b);
+    }
+
+    private static double CharDiffer(char a, char b) {
+      return IntegerDiffer(a, b);
+    }
+
+    private static double VectorDiffer<T>(IReadOnlyList<T> estimated, IReadOnlyList<T> outcome, Func<T, T, double> differ) {
+      var length = Math.Min(estimated.Count, outcome.Count);
+      var result = 0d;
+
+      for (var i = 0; i < length; i++) {
+        result += differ(estimated[i], outcome[i]);
+      }
+
+      if (estimated.Count > outcome.Count) {
+        var remainingLength = estimated.Count - length;
+        for (var i = 0; i < remainingLength; i++)
+          result += differ(estimated[i], default(T));
+      }
+
+      return result;
+    }
+
+    private static double GetPrintDiffer(string estimated, string printResult, double worstResult) {
+      var distance = LevenshteinDistance(estimated, printResult);
+
+      return Math.Min(distance, worstResult);
+    }
+
+    private static double GetPrintDiffer(string estimated, IPrintStack printStack, double worstResult) {
+      var printResult = printStack.ToString();
+      var distance = LevenshteinDistance(estimated, printResult);
+
+      return Math.Min(distance, worstResult);
+    }
+
+    private static double GetVectorDiff<T>(IReadOnlyList<IReadOnlyList<T>> estimated, IPushStack<IReadOnlyList<T>> resultStack, double worstResult, Func<IReadOnlyList<T>, IReadOnlyList<T>, double> differ)
+      where T : IComparable {
+      if (estimated.Count == 0) return 0d;
+
+      var diff = 0d;
+      var comparableLength = Math.Min(estimated.Count, resultStack.Count);
+
+      if (!resultStack.IsEmpty) {
+
+        for (var i = 0; i < comparableLength; i++) {
+          diff += Math.Min(differ(estimated[i], resultStack[i]), worstResult);
+        }
+      }
+
+      var emptyTArray = new T[0];
+      for (var i = comparableLength; i < estimated.Count - comparableLength; i++) {
+        diff += differ(estimated[i], emptyTArray);
+      }
+
+      return diff;
+    }
+
+    private static double GetDiff<T>(IReadOnlyList<T> estimated, IPushStack<T> resultStack, double worstResult, Func<T, T, double> differ)
+      where T : IComparable {
+      if (estimated.Count == 0) return 0d;
+
+      var diff = 0d;
+      var comparableLength = Math.Min(estimated.Count, resultStack.Count);
+
+      if (!resultStack.IsEmpty) {
+        for (var i = 0; i < comparableLength; i++) {
+          diff += Math.Min(differ(estimated[i], resultStack[i]), worstResult);
+        }
+      }
+
+      for (var i = comparableLength; i < estimated.Count - comparableLength; i++) {
+        diff += differ(estimated[i], default(T));
+      }
+
+      return diff;
+    }
+
+    /// <summary>
+    /// https://www.dotnetperls.com/levenshtein
+    /// </summary>
+    private static int LevenshteinDistance(string source, string target) {
+      if (source == null && target == null) return 0;
+      if (source == null) return target.Length;
+      if (target == null) return source.Length;
+
+      int n = source.Length;
+      int m = target.Length;
+      int[,] d = new int[n + 1, m + 1];
+
+      // Step 1
+      if (n == 0) {
+        return m;
+      }
+
+      if (m == 0) {
+        return n;
+      }
+
+      // Step 2
+      for (int i = 0; i <= n; d[i, 0] = i++) {
+      }
+
+      for (int j = 0; j <= m; d[0, j] = j++) {
+      }
+
+      // Step 3
+      for (int i = 1; i <= n; i++) {
+        //Step 4
+        for (int j = 1; j <= m; j++) {
+          // Step 5
+          int cost = (target[j - 1] == source[i - 1]) ? 0 : 1;
+
+          // Step 6
+          d[i, j] = Math.Min(
+              Math.Min(d[i - 1, j] + 1, d[i, j - 1] + 1),
+              d[i - 1, j - 1] + cost);
+        }
+      }
+      // Step 7
+      return d[n, m];
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15289)
@@ -72,5 +72,6 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.BooleanStack);
+      var value = interpreter.BooleanStack.Pop();
+      interpreter.PrintStack.Push(value);
     }
   }
@@ -92,5 +93,6 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.CharStack);
+      var value = interpreter.CharStack.Pop();
+      interpreter.PrintStack.Push(value);
     }
   }
@@ -113,5 +115,6 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.ExecStack);
+      var value = interpreter.ExecStack.Pop();
+      interpreter.PrintStack.Push(value);
     }
   }
@@ -136,8 +139,5 @@
       var str = value.ToString(interpreter.Configuration.FloatStringFormat, CultureInfo.InvariantCulture);
 
-      if (interpreter.PrintStack.IsEmpty)
-        interpreter.PrintStack.Push(str);
-      else
-        interpreter.PrintStack.Top += str;
+      interpreter.PrintStack.Push(str);
     }
   }
@@ -180,5 +180,6 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.StringStack);
+      var value = interpreter.StringStack.Pop();
+      interpreter.PrintStack.Push(value);
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15289)
@@ -28,4 +28,17 @@
         ? customExpressions.Values.ElementAt(index - enabledExpressionCount)
         : MapToExpression(index, random, ercOptions, config);
+    }
+
+    internal static Expression MapToExpression(
+      int index,
+      IReadOnlyExpressionsConfiguration config) {
+
+      switch (index) {
+        case PushSolutionEncoding.Noop:
+          return Noop;
+      }
+
+      var name = config.EnabledExpressions[index];
+      return ExpressionTable.GetExpression(name);
     }
 
@@ -76,6 +89,6 @@
         instructions.InExpressionCount > 0) {
 
-        var nr = random.Next(0, instructions.InExpressionCount) + 1;
-        expression = ExpressionTable.InExpressionTable[nr];
+        var index = random.Next(0, instructions.InExpressionCount);
+        expression = ExpressionTable.InExpressionTable[index];
       } else {
         expression = GetRandomExpression(random, instructions);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs	(revision 15289)
@@ -1,20 +1,17 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Individual {
   using System.Collections.Generic;
-
-  using HeuristicLab.Core;
   using HeuristicLab.Encodings.IntegerVectorEncoding;
   using HeuristicLab.Optimization;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator;
 
   public static class IndividualExtensions {
 
-    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config, IRandom random) {
-      return individual.IntegerVector().ToPushProgram(config, random);
+    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config) {
+      return individual.IntegerVector().ToPushProgram(config);
     }
 
-    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config, IRandom random) {
+    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config) {
       //var currentIndex = 0;
       //var close = 0;
@@ -24,16 +21,15 @@
         var index = vector[i];
 
-        if (index == PushSolutionEncoding.End)
-          break;
+        if (index == PushSolutionEncoding.End) break;
+        if (index == PushSolutionEncoding.Noop) continue;
 
-        // skip noops
-        if (index == PushSolutionEncoding.Noop)
-          continue;
+        var name = config.EnabledExpressions[index];
+        var expression = ExpressionTable.GetExpression(name);
 
-        var expression = CodeGeneratorUtils.MapToExpression(
-          index,
-          random,
-          config.ErcOptions,
-          config);
+        //var expression = CodeGeneratorUtils.MapToExpression(
+        //  index,
+        //  random,
+        //  config.ErcOptions,
+        //  config);
 
         expressions.Add(expression);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15289)
@@ -5,4 +5,5 @@
   using System;
   using System.Collections;
+  using System.Globalization;
   using System.Reflection;
 
@@ -26,20 +27,51 @@
     }
 
-    public static Type GetStackEntryType(this StackTypes stackType) {
-      if (StackProperties.ContainsKey(stackType) &&
-          StackProperties[stackType].PropertyType.IsGenericType) {
-        var genericTypeDef = StackProperties[stackType].PropertyType.GetGenericTypeDefinition();
-        if (genericTypeDef == typeof(IPushStack<>))
-          return genericTypeDef.GetGenericArguments()[0];
+    public static string StringifyResult(this IPushInterpreter interpreter, ExampleArgumentType type, int offset) {
+      var emptyString = string.Empty;
+
+      switch (type) {
+        case ExampleArgumentType.Integer:
+          return GetEntryAsString(offset, interpreter.IntegerStack);
+
+        case ExampleArgumentType.IntegerVector:
+          return GetVectorEntryAsString(offset, interpreter.IntegerVectorStack);
+
+        case ExampleArgumentType.Float:
+          return interpreter.FloatStack.Count > offset
+            ? interpreter.FloatStack[offset].ToString(CultureInfo.CurrentUICulture)
+            : emptyString;
+
+        case ExampleArgumentType.FloatVector:
+          return GetVectorEntryAsString(offset, interpreter.FloatVectorStack);
+
+        case ExampleArgumentType.Boolean:
+          return GetEntryAsString(offset, interpreter.BooleanStack);
+
+        case ExampleArgumentType.Char:
+          return GetEntryAsString(offset, interpreter.CharStack);
+
+        case ExampleArgumentType.Print:
+          return interpreter.PrintStack.ToString();
+
+        case ExampleArgumentType.String:
+          return GetEntryAsString(offset, interpreter.StringStack);
+
+        case ExampleArgumentType.StringVector:
+          return GetVectorEntryAsString(offset, interpreter.StringVectorStack);
+
+        default: return string.Empty;
       }
+    }
 
-      return StackProperties.ContainsKey(stackType)
-        ? StackProperties[stackType]
-            .PropertyType
-            .GetInterfaces()
-            .First(i => i.IsGenericType && i.GetGenericTypeDefinition() == typeof(IPushStack<>))
-            .GetGenericArguments()
-            .First()
-        : null;
+    private static string GetEntryAsString<T>(int offset, IPushStack<T> stack) {
+      return stack.Count > offset
+       ? stack[offset].ToString()
+       : string.Empty;
+    }
+
+    private static string GetVectorEntryAsString<T>(int offset, IPushStack<IReadOnlyList<T>> vectorStack) {
+      return vectorStack.Count > offset
+       ? "[" + string.Join(",", vectorStack[offset]) + "]"
+       : string.Empty;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Manipulator/UniformMutation.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Manipulator/UniformMutation.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Manipulator/UniformMutation.cs	(revision 15289)
@@ -1,3 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Manipulator {
+
   using HeuristicLab.Common;
   using HeuristicLab.Core;
@@ -11,5 +12,4 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
-  using HeuristicLab.Random;
 
   /// <summary>
@@ -23,12 +23,11 @@
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
       Parameters.Add(new LookupParameter<PlushVector>("PlushVector", "The vector which should be manipulated."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("MinLength", "The min length of the vector."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("MaxLength", "The max length of the vector."));
       Parameters.Add(new ValueLookupParameter<IReadOnlyExpressionsConfiguration>("Instructions", "The enabled instructions"));
       Parameters.Add(new ValueLookupParameter<IReadOnlyErcOptions>("ErcOptions", "ERC options"));
       Parameters.Add(new ValueLookupParameter<PercentValue>("InInstructionProbability", "The probability of IN Instructions"));
 
-      Parameters.Add(new FixedValueParameter<PercentValue>("InstructionMutationProbability", "The probability a value gets mutated", new PercentValue(0.02)));
-      Parameters.Add(new FixedValueParameter<DoubleValue>("CloseMutationDeviation", "When mutating individual, the amount of which the close marker is incremented or decrement is based on a random sample from a normal distribution with mean 0 and standard deviation set by the close mutation deviation parameter", new DoubleValue(1.0)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("InstructionMutationProbability", "The probability an instruction gets mutated", new PercentValue(0.02)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("CloseMutationProbability", "The probability close gets mutated", new PercentValue(0.02)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("CloseIncrementRate", "When mutating individual, the increment rate specifies if close should be increased or decreased by 1.", new PercentValue(0.5)));
     }
 
@@ -50,13 +49,24 @@
     }
 
-    public IValueParameter<PercentValue> CloseMutationDeviationParameter
+    public IValueParameter<PercentValue> CloseMutationProbabilityParameter
     {
-      get { return (IValueParameter<PercentValue>)Parameters["CloseMutationDeviation"]; }
+      get { return (IValueParameter<PercentValue>)Parameters["CloseMutationProbability"]; }
     }
 
-    public double CloseMutationDeviation
+    public double CloseMutationProbability
     {
-      get { return CloseMutationDeviationParameter.Value.Value; }
-      set { CloseMutationDeviationParameter.Value.Value = value; }
+      get { return CloseMutationProbabilityParameter.Value.Value; }
+      set { CloseMutationProbabilityParameter.Value.Value = value; }
+    }
+
+    public IValueParameter<PercentValue> CloseIncrementRateParameter
+    {
+      get { return (IValueParameter<PercentValue>)Parameters["CloseIncrementRate"]; }
+    }
+
+    public double CloseIncrementRate
+    {
+      get { return CloseIncrementRateParameter.Value.Value; }
+      set { CloseIncrementRateParameter.Value.Value = value; }
     }
 
@@ -72,12 +82,4 @@
     {
       get { return (ILookupParameter<PlushVector>)Parameters["PlushVector"]; }
-    }
-    public IValueLookupParameter<IntValue> MinLengthParameter
-    {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MinLength"]; }
-    }
-    public IValueLookupParameter<IntValue> MaxLengthParameter
-    {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MaxLength"]; }
     }
     public IValueLookupParameter<IReadOnlyExpressionsConfiguration> InstructionsParameter
@@ -99,14 +101,26 @@
 
     public sealed override IOperation InstrumentedApply() {
-      Manipulate(RandomParameter.ActualValue, PlushVectorParameter.ActualValue);
+      Manipulate(
+        RandomParameter.ActualValue,
+        PlushVectorParameter.ActualValue,
+        CloseIncrementRate,
+        ErcOptionsParameter.ActualValue,
+        InstructionsParameter.ActualValue,
+        InInstructionProbabilityParameter.ActualValue.Value,
+        CloseMutationProbability,
+        InstructionMutationProbability);
       return base.InstrumentedApply();
     }
 
-    private void Manipulate(IRandom random, PlushVector plushVector) {
-      var normalDistributedRandom = new NormalDistributedRandom(random, 0, CloseMutationDeviation);
-      var ercOptions = ErcOptionsParameter.ActualValue;
-      var instructions = InstructionsParameter.ActualValue;
-      var inInstructionProbability = InInstructionProbabilityParameter.ActualValue.Value;
-      var instructionMutationProbability = InstructionMutationProbability;
+    private static void Manipulate(
+      IRandom random,
+      PlushVector plushVector,
+      double closeIncrementRate,
+      IReadOnlyErcOptions ercOptions,
+      IReadOnlyExpressionsConfiguration instructions,
+      double inInstructionProbability,
+      double closeMutationProbability,
+      double instructionMutationProbability
+      ) {
 
       for (var i = 0; i < plushVector.Entries.Count; i++) {
@@ -123,5 +137,13 @@
         }
 
-        entry.Close += normalDistributedRandom.Next();
+        x = random.NextDouble();
+
+        if (x < closeMutationProbability) {
+          x = random.NextDouble();
+          entry.Close += x < closeIncrementRate ? 1 : -1;
+
+          if (entry.Close < 0)
+            entry.Close = 0;
+        }
       }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/Random/SeededRandomPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/Random/SeededRandomPool.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/Random/SeededRandomPool.cs	(revision 15289)
@@ -12,5 +12,5 @@
     public SeededRandomPool() : this(new Random().Next()) { }
 
-    public SeededRandomPool(int seed) : this(seed, () => new MersenneTwister()) { }
+    public SeededRandomPool(int seed) : this(seed, () => new FastRandom()) { }
 
     public SeededRandomPool(int seed, Func<IRandom> randomCreator) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/IntegerVectorPushBenchmarkSuiteProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/IntegerVectorPushBenchmarkSuiteProblem.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/IntegerVectorPushBenchmarkSuiteProblem.cs	(revision 15289)
@@ -7,5 +7,8 @@
   using HeuristicLab.BenchmarkSuite;
   using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Solution;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Solution.BenchmarkSuite;
 
   using Instances;
